setwd("path to your data/")
### use "sed '2,2d' myTable_sampleID_genus_L3.txt > myTable_ sampleID _genus_L3_2d.txt" in order to delete the second line in the files
###use "sed s/\"\"/\"unclassified\"/ myTable_ sampleID _genus_L3.txt > myTable_ sampleID _genus_L3_unc.txt to put "unclassified" inside the line which is empty
myTable <- NULL

#myTable[[1]] <- read.table(file="test1.txt", header=TRUE)
#myTable[[2]] <- read.table(file="test2.txt", header=TRUE)

myTable[[1]] <- read.table(file="myTable_sampleID1_genus_L3_renamed.txt", header=TRUE)
myTable[[2]] <- read.table(file="myTable_sampleID2_genus_L3_renamed.txt", header=TRUE)
myTable[[3]] <- read.table(file="myTable_sampleID3_genus_L3_renamed.txt", header=TRUE)
myTable[[4]] <- read.table(file="myTable_sampleID4_genus_L3_renamed.txt", header=TRUE)
myTable[[5]] <- read.table(file="myTable_sampleID5_genus_L3_renamed.txt", header=TRUE)
# ... add more files here

numberOfTables <- length(myTable)

# get unique names of species and functions across all data sets

myColnames <- NULL
myRownames <- NULL

for (i in 1:numberOfTables) {
  myColnames <- union(myColnames, colnames(myTable[[i]]))
  myRownames <- union(myRownames, rownames(myTable[[i]]))
}

# expand each table so that all rownames and colnames are present

for (i in 1:numberOfTables) {
  
  # add columns
  
  columnsToAdd <- setdiff(myColnames, colnames(myTable[[i]]))
  
  newCols <- data.frame(matrix(0, nrow = nrow(myTable[[i]]), ncol = length(columnsToAdd)))
  rownames(newCols) <- rownames(myTable[[i]])
  colnames(newCols) <- columnsToAdd
  
  newTable <- cbind(myTable[[i]], newCols)
  
  myTable[[i]] <- newTable
  
  # add rows
  
  rowsToAdd <- setdiff(myRownames, rownames(myTable[[i]]))
  
  newRows <- data.frame(matrix(0, nrow = length(rowsToAdd), ncol(myTable[[i]])))
  rownames(newRows) <- rowsToAdd
  colnames(newRows) <- colnames(myTable[[i]])
  
  newTable <- rbind(myTable[[i]], newRows)
  
  myTable[[i]] <- newTable
  
}

# sort all tables so that we can easily add up values in the next step

for (i in 1:numberOfTables) {
  # sorting rows 
  sorted <- myTable[[i]][order(rownames(myTable[[i]])),]
  myTable[[i]] <- sorted
  # sorting columns
  sorted <- myTable[[i]][,order(colnames(myTable[[i]]))]
  myTable[[i]] <- sorted
}

# sum entries

result <- myTable[[1]]
for (i in 2:numberOfTables) {
  result <- result + myTable[[i]]
}

# save result

write.table(result, file="combinedTable_genus_L3.txt")
